import { InjectionToken } from '@nestjs/common';
import { MongoClientOptions, MongoDatabaseOptions } from './mongodb';
export type Class<TConstructor = any> = new (...args: Array<any>) => TConstructor;
export type Options = Record<string, any>;
export type ForRootOptions<TOptions extends Options> = TOptions;
export type ForRootAsyncOptions<TOptions extends Options> = {
    inject: Array<InjectionToken>;
    useFactory: (...args: Array<any>) => Promise<TOptions> | TOptions;
};
export type MongoModuleOptions = {
    uri: string;
    client?: MongoClientOptions;
    database?: MongoDatabaseOptions;
};
export type ColumnOptions = {
    unique?: boolean;
    lock?: boolean;
};
export type EntityColumn = {
    propertyKey: string;
    options: ColumnOptions;
};
export type EntityMetadata = {
    columns: Array<EntityColumn>;
};
export type Lock = {
    inTransit: boolean;
};
